package bou.amine.apps.readerforselfossv2.utils

import android.os.Build
import android.text.format.DateUtils
import bou.amine.apps.readerforselfossv2.service.AppSettingsService
import java.time.Instant
import java.time.LocalDateTime
import java.time.OffsetDateTime
import java.time.ZoneOffset
import java.time.format.DateTimeFormatter

actual class DateUtils actual constructor(actual val appSettingsService: AppSettingsService) {

    actual fun parseDate(dateString: String): Long {

        val FORMATTERV1 = "yyyy-MM-dd HH:mm:ss"

        return if (appSettingsService.getApiVersion() >= 4) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                OffsetDateTime.parse(dateString).toInstant().toEpochMilli()
            } else {
                TODO("VERSION.SDK_INT < O")
            }
        } else {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                LocalDateTime.parse(dateString, DateTimeFormatter.ofPattern(FORMATTERV1)).toInstant(
                    ZoneOffset.UTC).toEpochMilli()
            } else {
                TODO("VERSION.SDK_INT < O")
            }
        }
    }

    actual fun parseRelativeDate(dateString: String): String {

        val date = parseDate(dateString)

        return if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            " " + DateUtils.getRelativeTimeSpanString(
                date,
                Instant.now().toEpochMilli(),
                DateUtils.MINUTE_IN_MILLIS,
                DateUtils.FORMAT_ABBREV_RELATIVE
            )
        } else {
            TODO("VERSION.SDK_INT < O")
        }
    }
}